VERSION 5.00
Begin VB.Form MainForm 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00400000&
   BorderStyle     =   0  'None
   Caption         =   "Screen Saver Main Form"
   ClientHeight    =   6555
   ClientLeft      =   3660
   ClientTop       =   2115
   ClientWidth     =   5775
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   6555
   ScaleWidth      =   5775
   ShowInTaskbar   =   0   'False
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Fichier Mainform.Frm
' --------------------

Option Explicit

'For information about this program see the declarations
'section of the JDSaver.BAS module (ScreenSaver.bas maintenant).

'This form is the screen saver output, and will cover the screen.
'It is called from Sub Main when the program is started with
'the /s command parameter

Private Sub Form_Load()

    'Make the screen saver a TOPMOST window
    Const HWND_TOPMOST = -1
    Const SWP_NOMOVE = &H2
    Const SWP_NOSIZE = 1
    Const FLAGS = SWP_NOMOVE Or SWP_NOSIZE
    
    ' En mode debug, dsactiver cette ligne !
    Dim lRet&
    If Not bDebug Then
        lRet = SetWindowPos(hwnd, HWND_TOPMOST, 0, 0, 0, 0, FLAGS)
    End If
    
    'Make the form exactly cover the screen
    Move 0, 0, Screen.Width, Screen.Height
    
    'Find out from the System Registry if the user
    'has enabled password protection for screen savers.
    Const HKEY_CURRENT_USER = &H80000001
    lRet = Val(RegGetValue(HKEY_CURRENT_USER, "Control Panel\Desktop", "ScreenSaveUsePassword"))
    If lRet <> 0 Then Var.bPWProtect = True
      
    'Find out if we are running under NT
    Var.lWinOS = lGetVersionWindows32
    
    'Disable Ctrl-Alt-Del if appropriate. NT handles password-protected
    'screen savers at the system level, so this is only needed for non-NT
    'situations with password protection enabled.
    If Var.bPWProtect And Var.lWinOS <> lWinNT Then
        lRet = SystemParametersInfo(SPI_SCREENSAVERRUNNING, 1&, 0&, 0&)
    End If

    'Copy a clone of the desktop onto the form, to
    'serve as a background for the circle painting
    'CopyScreen Me
    
    Me.AutoRedraw = False
    Me.Cls

    AffichageSouris False

End Sub

Private Sub Form_Activate()

    If Not Var.bDemarrerUneSeuleFois Then
        Var.bDemarrerUneSeuleFois = True
        DepartDessin Me, FrmImages!pboxImgFond, FrmImages!pboxImgSprite
    End If
    
    If Var.bQuitterApplication Then
        Unload Me ' Provoque un Form_Unload et quitte le prog
    End If
    
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    
    If bVerifierPwd() Then _
        Var.bEscapeSimulation = True: Var.bQuitterApplication = True
    
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If bVerifierPwd() Then _
        Var.bEscapeSimulation = True: Var.bQuitterApplication = True
    
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    Var.iNbMouseMoves = Var.iNbMouseMoves + 1
    
    'There will probably be a MouseMove event or two at
    'startup that need to be eaten.
    'Change value for more or less mouse sensitivity
    'If you want to get fancy, add a scroll bar on the
    'configuration form to let the user select sensitivity.
    If Var.iNbMouseMoves >= 5 Then
        If bVerifierPwd() Then _
            Var.bEscapeSimulation = True: Var.bQuitterApplication = True
        ' Dsensibiliser la souris un peu
        Var.iNbMouseMoves = 0
    End If
    
    'MouseMove events are cumulative, so over time there
    'might be "mouse creep."  Reset the counter if more
    'than 10 seconds have elapsed since mouse movement began.
    'Static TimeDelay&
    'If TimeDelay = 0 Then
    '    TimeDelay = Timer
    'ElseIf Timer - TimeDelay > 10 Then
    '    TimeDelay = 0
    '    Var.iNbMouseMoves = 0
    'End If
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    AffichageSouris True
    
    're-enable Ctrl-Alt-Del if disabled
    If Var.bPWProtect And Var.lWinOS <> lWinNT Then
        Dim lRet&
        lRet = SystemParametersInfo(SPI_SCREENSAVERRUNNING, 0&, 0&, 0&)
    End If
    
    Unload FrmImages
         
End Sub

Private Function bVerifierPwd() As Boolean
    
    'Before we exit, we need to input a password if
    'password protection is enabled.  NT handles its own password
    'routines.  Thanks to Piotr Mintus for information on
    'the use of VerifyScreenSavePwd
    
    ' A partir de l'vnement MouseMove, on risque d'entrer svt ici :
    '  ne pas demander plusieurs fois le pwd
    Static bVerifPwdEnCours As Boolean
    If bVerifPwdEnCours Then Exit Function
    bVerifPwdEnCours = True
    
    bVerifierPwd = True
    If Var.bPWProtect And Var.lWinOS <> lWinNT Then
        Dim PassChck As Boolean
        'We need a cursor so that the user can move around
        'the password form
        AffichageSouris True
        PassChck = VerifyScreenSavePwd(Me.hwnd)
        If PassChck = False Then
            bVerifierPwd = False
            AffichageSouris False
        End If
    End If
    bVerifPwdEnCours = False
    
End Function
